import java.util.ArrayList;
import java.util.Random;


public class GenEngine {
	/* =Constants */
	
	// population
	public static int popSize = 100;
	
	public static float	selectionPercent = (float) 1;
	
	// mutation
	public static float probMutTag = (float) .1;
	public static float probMutTol = (float) .1;
	
	//public static float rateMutTol	= (float) 1;
	
	// altruism
	public static float giveCost = (float) .1;
	public static float giveBenefit = (float) 1;
	public static int numDonations = 3;
	
	/* =Attrs */
	ArrayList<Individual>	population;
	
	Random r = new Random();
	
	public void generateInitPopulation(){
		population = new ArrayList<Individual>();
		for(int i = 0; i < popSize; i++){
			population.add(new Individual());
		}		
	}
	
	public void generatePopulation(){
		population = runTournament();
		
		while(population.size() < popSize){
			// fill remaining space in population with random individuals 
			// TODO: maybe later clone from winners
			population.add(new Individual());
		}
	}
	
	public void runPopulation(){
		for(int i = 0; i < population.size(); i++){
			Individual ind = population.get(i);
			
			for(int j = 0; j < numDonations; j++){
				ind.donate(population.get(chooseOther(i)));
			}
		}
	}
	
	public ArrayList<Individual> runTournament(){
		ArrayList<Individual> nextGeneration = new ArrayList<Individual>();
		
		int tournamentCount = Math.round(population.size() * selectionPercent);
		for(int i = 0; i < tournamentCount; i++){
			Individual ind  = population.get(i);
			Individual other = population.get(chooseOther(i));
			
			if(ind.score >= other.score){
				nextGeneration.add(ind.reproduce());
			}
			else {
				nextGeneration.add(other.reproduce());
			}			
		}
		
		return nextGeneration;
	}
	
	public float averageScore(){
		float totalScore = (float) 0;
		for(Individual ind : population){
			totalScore += ind.score;
		}
		return totalScore / popSize;
	}
	
	public float averageTolerance(){
		float totalTolerance = (float) 0;
		for(Individual ind : population){
			totalTolerance += ind.tolerance;
		}
		return totalTolerance / popSize;
	}
	
	public float donationRate() {
		int donateCount = 0;
		for (Individual ind : population) {
			donateCount += ind.donateCount;
		}
		
		return donateCount / ((float) popSize * 3);
	}
	
	public int chooseOther(int index){
		int otherIndex = r.nextInt(population.size());
		while(otherIndex == index)
			otherIndex = r.nextInt(population.size());
		return otherIndex;
	}
			
}
