import java.util.Random;


public class Individual {
	
	public float score, tag, tolerance;
	public int donateCount;
	//public int reach;
	
	Random r = new Random();
	
	public Individual(){
		score = (float) 0.0;
		tag = r.nextFloat();
		tolerance = r.nextFloat();
		donateCount = 0;
	}
	
	public Individual(float tag, float tolerance){
		this.tag = tag;
		this.tolerance = tolerance;
		score = (float) 0.0;
		donateCount = 0;
	}
	
	public Individual reproduce() {
		// Apply mutations (based on chance)
		if(r.nextFloat() < GenEngine.probMutTag)
			mutateTag();
		if(r.nextFloat() < GenEngine.probMutTol)
			mutateTol();
		
		// Return (possibly mutated) self
		return new Individual(tag, tolerance);
	}
	
	public void mutateTag(){
		tag = r.nextFloat();
	}
	
	public void mutateTol(){
  	float change = (float) (r.nextGaussian() * (double) .0001); // generate gaussian noise (mean = 0, SD = .01)
																															// riolo-like results for SD .0001
		// box-muller gaussian noise algorithm, same results as above
		//float change = (float) ((Math.sqrt(-2.0 * Math.log(r.nextDouble())) * Math.cos(2.0 * Math.PI * r.nextDouble())) * (double) .0001);

		tolerance += change;

		if (tolerance < 0) tolerance = 0;
	}
	
	public void donate(Individual ind) {
		if (Math.abs(ind.tag - tag) < tolerance) { // donate if tag difference is below tolerance
			ind.score += GenEngine.giveBenefit;
			score -= GenEngine.giveCost;
			
			donateCount++;
		}
	}
	
}
