public class Main {
	
	static int numRuns = 30;
	static int numGens = 30000;
	
	public static void main(String[] args) {
		GenEngine engine = new GenEngine();
		
		float avgScore, avgTolerance, donationRate;
		float allAvgScore, allAvgTolerance, allDonationRate;
		allAvgScore = allAvgTolerance = allDonationRate = (float) 0.0;
		
		// Perform run of simulation
		for (int i = 0; i < numRuns; i++) {
			engine.generateInitPopulation(); // initial random population
			
			avgScore = (float) 0;
			avgTolerance = (float) 0;
			donationRate = (float) 0;
			
			// Run a generation
			for(int j = 0; j < numGens; j++){
				engine.runPopulation();
				
				avgScore += engine.averageScore();
				avgTolerance += engine.averageTolerance();
				donationRate += engine.donationRate();
				
				engine.generatePopulation();
			}
			
			// Averages for this run
			avgScore /= (float) numGens;
			avgTolerance /= (float) numGens;
			donationRate = (donationRate / (float) numGens) * 100;
			
			System.out.println("(run " + (i+1) + " of " + numRuns + ") " + "score: " + avgScore + " tolerance: " + avgTolerance + " donation %: " + donationRate);
			
			// Cumulative average across all runs
			allAvgScore += avgScore;
			allAvgTolerance += avgTolerance;
			allDonationRate += donationRate;
		}
		
		allAvgScore /= numRuns;
		allAvgTolerance /= numRuns;
		allDonationRate /= numRuns;
		
		System.out.println("\nfinal results:\n" + "score: " + allAvgScore + " tolerance: " + allAvgTolerance + " donation %: " + allDonationRate);
		
	}

	
	
}
